
{.$define Debug}

program Solution;
{$M 16384,0,655360}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxK                          = 100;
  maxN                          = 100;
  msgQuantumSatis               = 'QUANTUM SATIS';
  blanks                        = [#10,#13,#32,#9,#26];
  intLen                        = 20;

type
  TName                         = string[10];

  TSet                          = set of 1..maxK;

  TReact                        = record
    source                      : integer;
    target                      : TSet;
  end;

  TInt                          = object
    d                           : array[1..intLen] of integer;
    len				: integer;
    constructor                 Init( a : integer );
    constructor                 Copy( var int : TInt );
    procedure                   Add( var int : TInt );
    function                    IsGreater( var int : TInt ) : boolean;
    procedure                   Print;
  end;

var
  n                             : integer;
  k                             : integer;
  names                         : array[1..maxK] of TName;
  start                         : array[1..maxK] of integer;
  fin                           : array[1..maxK] of integer;
  rlist                         : array[1..maxK] of integer;
  r                             : array[1..maxN] of TReact;
  pb                            : integer;
  au                            : integer;
  answer                        : TInt;
  eol                           : boolean;
  g                             : array[1..maxK] of TInt;
  qs				: boolean;

constructor TInt.Init( a : integer );
begin
  fillchar( d, sizeof(d), 0 );
  d[1] := a;
  len := 1;
end;

constructor TInt.Copy( var int : TInt );
begin
  move( int, self, sizeof(int) );
end;

procedure WriteData; forward;
procedure Finalize; forward;

procedure TInt.Add( var int : TInt );
var
  i                             : integer;
  x                             : longint;
  y                             : integer;

begin
  y := 0;
  for i := 1 to intLen do begin
    if (i > len) and (i > int.len) and (y = 0) then begin
      len := i - 1;
      if len > intLen then begin
        qs := true;
        WriteData;
        Finalize;
      end;
      exit;
    end;
    x := longint( y  ) + d[i] + int.d[i];
    if x >= 1000 then begin
      y := 1;
      d[i] := x - 1000;
    end else begin
      y := 0;
      d[i] := x;
    end;
  end;
  qs := true;
  WriteData;
  Finalize;
end;

function TInt.IsGreater( var int : TInt ) : boolean;
var
  i                             : integer;

begin
  for i := intLen downto 1 do begin
    if d[i] < int.d[i] then begin
      IsGreater := false;
      exit;
    end;
    if d[i] > int.d[i] then begin
      IsGreater := true;
      exit;
    end;
  end;
  IsGreater := false;
end;

procedure TInt.Print;
var
  s                             : string;
  i,j                           : integer;

begin
  i := intLen;
  while (i > 0) and (d[i] = 0) do dec( i );
  if i = 0 then begin
    writeln( 0 );
    exit;
  end;
  for j := i downto 1 do begin
    str( d[j], s );
    if j <> i then
      while length( s ) <> 3 do s := '0' + s;
    write( s );
  end;
  writeln;
end;

function Find( s : string ) : integer;
var
  i                             : integer;

begin
  for i := 1 to k do
    if names[i] = s then begin
      Find := i;
      exit;
    end;
end;

function Update : boolean;
var
  i,j,l                         : integer;
  react                         : integer;
  sum                           : TInt;
  max                           : TInt;

begin
  Update := false;
  for i := 1 to k do begin
    max.Init( 0 );
    for j := start[i] to fin[i] do begin
      react := rlist[j];
      sum.Init( 0 );
      for l := 1 to k do
        if l in r[react].target then sum.Add( g[l] );
      if sum.IsGreater( max ) then max.Copy( sum );
    end;
    if max.IsGreater( g[i] ) then begin
      Update := true;
      g[i].Copy( max );
    end;
  end;
end;

procedure BuildRList;
var
  i,j,p                         : integer;

begin
  p := 1;
  for i := 1 to k do begin
    start[i] := p;
    for j := 1 to n do
      if r[j].source = i then begin
        rlist[p] := j;
        inc( p );
      end;
    fin[i] := p - 1;
  end;
end;

procedure Solve;
var
  i                             : integer;

begin
  au := Find( '' );
  pb := Find( 'ᢨ' );
  BuildRList;
  for i := 1 to k do g[i].Init( 0 );
  g[au].Init( 1 );
  for i := 1 to k + 2 do
    if not Update then break;
  answer.Copy( g[pb] );
  Update;
  qs := g[pb].IsGreater( answer );
end;

function str2int( s : string ) : integer;
var
  x                             : integer;
  code                          : integer;

begin
  val( s, x, code );
  str2int := x;
end;

function ReadLexem : string;
var
  s                             : string;
  ch                            : char;

begin
  s := '';
  repeat
    read( ch );
  until not (ch in blanks);
  s := ch;
  repeat
    read( ch );
    if ch in blanks then break;
    s := s + ch;
  until false;
  eol := ch in [#10,#13,#26];
  if eol then read( ch );
  ReadLexem := s;
end;

procedure ReadData;
var
  i				: integer;

begin
  k := str2int( ReadLexem );
  for i := 1 to k do names[i] := ReadLexem;
  n := str2int( ReadLexem );
  if not eol then readln;
  for i := 1 to n do begin
    r[i].source := Find( ReadLexem );
    if not eol then readln;
    r[i].target := [];
    if SeekEOLn( input ) then begin
      readln;
      continue;
    end;
    repeat
      include( r[i].target, Find( ReadLexem ) );
      if not eol then
        if SeekEOLn( input ) then begin
          readln;
          break;
        end;
    until eol;
  end;
end;

procedure WriteData;
var
  i				: integer;

begin
  if qs then
    writeln( msgQuantumSatis )
  else
    answer.Print;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.