{襭  "ࠢ ।" }
{. ஭, 28.07.98, ᫠    }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q+,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
label newiter;
const maxlen=3000;
      maxwords=500;
      maxwordlen=30;

type strword=string[maxwordlen];
     longstr=array[1..maxlen] of char;
     TGenre=(male,female,neutral);

const
      hundreds:array[1..9] of strword=('','','','','',
                                      ' ','ᥬ','ᥬ','');
      tens:array[1..9] of strword=('','','ਤ','ப','줥',
                                  '줥','ᥬ줥','ᥬ줥','ﭮ');
      units:array[3..19] of strword=('','','','','ᥬ','ᥬ','','',
                                    '','','ਭ','ୠ','⭠',
                                    '⭠','ᥬ','ᥬ','⭠');

      russianletters=[''..'',''..'',''..''];


var dict: array[0..maxwords] of record
            w: strword;
            c: byte;
            q: boolean;
          end;
    dictfill : integer;

    ls1,ls2: longstr;

    iter : integer;

function Spell(n : integer):string;
begin
  if n>=1000 then Spell := '  ' + Spell(n mod 1000)
  else if n>=100 then Spell := hundreds[n div 100]+' '+Spell(n mod 100)
  else if n>=20 then Spell := tens[n div 10] + ' '
  else if n>=10 then Spell := units[n] + ' '
  else Spell := '';
end;

function SpellWord(n: integer; w1,w234,wmany: string; g: TGenre):string;
var s : string;
begin
  if not(n mod 100 in [10..19]) then
    case n mod 10 of
      0: s := wmany;
      1: case g of
           male   : s := ' '+w1;
           female : s := ' '+w1;
           neutral: s := ' '+w1;
         end;
      2: case g of
           male   : s := ' '+w234;
           female : s := ' '+w234;
           neutral: s := ' '+w234;
         end;
      3,4: s := units[n mod 10]+' '+w234;
      5..9: s := units[n mod 10]+' '+wmany;
    end
  else s := wmany;
  if n>=10 then s := Spell(n)+s;
  SpellWord := s;
end;

function GetNextToken(var ls: longstr; var ptr: integer):strword;
var s : string;
begin
  while (ls[ptr]<>#0) and not(ls[ptr] in russianletters) do inc(ptr);
  s := '';
  while ls[ptr] in russianletters do begin
    s := s+ls[ptr];
    inc(ptr);
  end;
  if length(s)>maxwordlen then begin writeln('');Halt(1); end;
  GetNextToken := s;
end;

function FoundInDict(s : strword): integer;
var i : integer;
begin
  for i := 1 to dictfill do begin
    if dict[i].w=s then begin
      FoundInDict := i;
      exit;
    end;
  end;
  FoundInDict := 0;
end;

procedure GenDict(var ls: longstr);
var p,ptr : integer;
    s : strword;
begin
  dictfill := 0;
  ptr := 1;
  while ls[ptr]<>#0 do begin
    s := GetNextToken(ls,ptr);
    if s<>'' then begin
      p := FoundInDict(s);
      if p=0 then begin
        inc(dictfill);
        p := dictfill;
        dict[p].w := s;
        dict[p].c := 1;
        dict[p].q := true;
      end else
        inc(dict[p].c);
      dict[p].q := dict[p].q and (ls[ptr]='"');
    end;
  end;
end;

procedure SortDict;
var i,j : integer;
begin
  for i := dictfill downto 2 do
    for j := 1 to i-1 do
      if dict[j].w>dict[j+1].w then begin
        dict[0] := dict[j];
        dict[j] := dict[j+1];
        dict[j+1] := dict[0];
      end;
end;


function CountSymbol(ch: char;var ls: longstr): integer;
var sum,ptr : integer;
begin
  sum := 0;
  ptr := 1;
  while ls[ptr]<>#0 do begin
    if ls[ptr]=ch then inc(sum);
    inc(ptr);
  end;
  CountSymbol := sum;
end;

procedure AddTolongstring(s: string;var ls: longstr);
var i,ptr : integer;
begin
  ptr := 1;
  while ls[ptr]<>#0 do inc(ptr);
  for i := 1 to length(s) do begin
    ls[ptr] := s[i];
    inc(ptr);
  end;
  ls[ptr] := #0;
end;

function CountWords(var ls: longstr): integer;
var sum,ptr : integer;
    s : string;
begin
  ptr := 1;
  sum := 0;
  while ls[ptr]<>#0 do begin
    s := GetNextToken(ls,ptr);
    if s<>'' then inc(sum);
  end;
  CountWords := sum;
end;

function CountLetters(var ls: longstr): integer;
var sum,ptr : integer;
    s : string;
begin
  ptr := 1;
  sum := 0;
  while ls[ptr]<>#0 do begin
    s := GetNextToken(ls,ptr);
    inc(sum,length(s));
  end;
  CountLetters := sum;
end;

procedure GenSentence(var lso,lsn: longstr);
var i,occur,virg,space: integer;
    s : string;
begin
  lsn[1] := #0;
  AddTolongstring(' ⮬ ।  窠,',lsn);

  occur := CountSymbol(',',lso);
  s := SpellWord(occur,'','','',female);
  AddTolongstring(' '+s+',',lsn);

  occur := CountSymbol(' ',lso);
  s := SpellWord(occur,'஡','஡','஡',male);
  AddTolongstring(' '+s+',',lsn);

  occur := CountSymbol('"',lso);
  s := SpellWord(occur,'窠','窨','祪',female);
  AddTolongstring(' '+s+',',lsn);

  occur := CountLetters(lso);
  s := SpellWord(occur,'㪢','㪢','㪢',female);
  AddTolongstring(' '+s+',',lsn);

  occur := CountWords(lso);
  s := SpellWord(occur,'᫮','᫮','᫮',neutral);
  AddTolongstring(' '+s,lsn);

  GenDict(lso);
  {SortDict;}

  for i := 1 to dictfill do {if not dict[i].q then}
  begin
    occur := dict[i].c;
    s := SpellWord(occur,'᫮','᫮','᫮',neutral);
    s := ', '+s+' "'+dict[i].w+'"';
    AddTolongstring(s,lsn);
  end;

  AddTolongstring('.',lsn);
end;

procedure Printlongstring(var ls: longstr);
var ptr : integer;
begin
  ptr := 1;
  while ls[ptr]<>#0 do begin
    write(ls[ptr]);
    inc(ptr);
  end;
end;

function Lengthlongstring(var ls: longstr): integer;
var ptr : integer;
begin
  ptr := 1;
  while ls[ptr]<>#0 do begin
    inc(ptr);
  end;
  Lengthlongstring := ptr-1;
end;

function Equallongstring(var ls1,ls2: longstr): boolean;
var ptr : integer;
begin
  ptr := 1;
  while (ls1[ptr]<>#0) or (ls2[ptr]<>#0) do begin
    if ls1[ptr]<>ls2[ptr] then begin
      Equallongstring := false;
      exit;
    end;
    inc(ptr);
  end;
  Equallongstring := true;
end;

begin
  randomize;
  repeat
newiter:
    ls2[1] := #0;
    repeat
      case random(40) of
        0..10: AddTolongstring(hundreds[random(9)+1]+' ',ls2);
        11..20: AddTolongstring(tens[random(9)+1]+' ',ls2);
        21..30: AddTolongstring(units[random(19-3)+3]+' ',ls2);
        31 : AddTolongstring(' ',ls2);
        32 : AddTolongstring('窠 ',ls2);
        33 : AddTolongstring('᫮ ',ls2);
        34 : AddTolongstring('窠 ',ls2);
      end;
    until random<0.03;
    {assign(output,'output.txt');rewrite(output);}
    iter := 0;
    repeat
      ls1 := ls2;
      GenSentence(ls1,ls2);
      writeln(Lengthlongstring(ls2));
      inc(iter);
      if iter > 300 then goto newiter;
    until Equallongstring(ls1,ls2);
    Printlongstring(ls1);
    exit;
  until false;
end.