{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

const
  nMax = 10;
  maxPeriod = 1100;
  maxLen = 1000;

type
  tPos = set of 1..10;
  tNum = array[0..maxLen] of integer;

var
  a : array[1..nMax, 1..nMax] of boolean;
  c, oldc : tNum;
  n, v1, v2 : integer;
  perL, predL : integer;
  allPos : array[0..2*maxPeriod+1] of tPos;
  min : integer;

procedure init;
var
  s : string;
  i, j : integer;
begin
  assign(input, 'input.txt');
  reSet(input);

  readLn(N);
  for i := 1 to N do begin
    readLn(s);
    for j := 1 to N do
      a[i, j] := s[j] = '1';
  end;

  readLn(v1, v2);
  readLn(s);
  c[0] := length(s);
  for i := 1 to c[0] do
    c[i] := ord(s[c[0]-i+1])-ord('0');
  oldc := c;
end;

procedure getNext(var pos : tPos);
var
  i, j : integer;
  next : tPos;
begin
  next := [];
  for i := 1 to N do
    if i in pos then
      for j := 1 to N do
        if a[i, j] then
          include(next, j);

  pos := next;
end;

procedure findPeriod;
var
  pos, next : tPos;
  i : integer;
begin
  pos := [v1];
  allPos[1] := pos;
  for i := 1 to 2*maxPeriod do begin
    getNext(pos);
    allPos[i+1] := pos;
  end;

  next := pos; getNext(next);
  perL := 1;
  while next <> pos do begin
    getNext(next);
    inc(perL);
  end;

  pos := [v1];
  next := [v1];
  for i := 1 to perL do
    getNext(next);

  predL := 0;
  while next <> pos do begin
    inc(predL);
    getNext(next);
    getNext(pos);
  end;
end;

function toNum(const c : tNum) : longint;
var
  num, i : longint;
begin
  num := 0;
  for i := c[0] downto 1 do
    num := num*10+c[i];

  toNum := num;
end;

procedure dec(var a : tNum; n : integer);
var
  b : tNum;
  r, i : integer;
begin
  fillChar(b, sizeOf(b), 0);
  while n <> 0 do begin
    inc(b[0]);
    b[b[0]] := n mod 10;
    n := n div 10;
  end;

  r := 1;
  for i := 1 to a[0] do begin
    r := a[i]-b[i]+9+r;
    a[i] := r mod 10;
    r := r div 10;
  end;
  while (a[0] > 0) and (a[a[0]] = 0) do
    system.dec(a[0]);
end;

function Less(const c : tNum; num : integer) : boolean;
var
  a, i : longint;
begin
  if c[0] > 4 then
    Less := false
  else
    Less := toNum(c) < num;
end;

function _mod(var c : tNum; k : integer) : integer;
var
  ans : longint;
  i : integer;
begin
  ans := 0;
  for i := c[c[0]] downto 1 do
    ans := (ans*10+c[i]) mod k;

  _mod := ans;
end;

procedure search(k, down, up : integer; cycle : boolean);
var
  i : integer;
begin
  min := maxInt;
  i := k;
  while (i >= down) and not (v2 in allPos[i]) do
    system.dec(i);
  if i >= down then begin
    min := k-i;
    if cycle and (min > perL-min) then
      min := perL-min;
  end;

  i := k;
  while (i <= up) and not (v2 in allPos[i]) do
    inc(i);
  if (i <= up) and (min > i-k) then begin
    min := i-k;
    if cycle and (min > perL-min) then
      min := perL-min;
  end;

  if (min = maxInt) and cycle then begin
    i := predL;
    while (i > 0) and not (v2 in allPos[i]) do
      system.dec(i);

    if i > 0 then begin
      min := -1;
      dec(oldc, i-1);
    end;
  end;
end;

procedure print;
var
  i : integer;
begin
  assign(output, 'output.txt');
  reWrite(output);

  if min = 0 then
    writeLn('Yes')
  else
    writeLn('No');

  if (min <> -1) and (min < maxInt) then
    writeLn(min)
  else
    if min = -1 then begin
      for i := c[0] downto 1 do
        write(oldc[i]);
      writeLn;
    end
    else
      writeLn(-1);
end;

Begin
  init;
  findPeriod;
  if Less(c, perL+predL) then
    search(toNum(c)+1, 1, predL+perL, false)
  else begin
    dec(c, predL);
    search(_mod(c, perL)+predL+1, predL+1, predL+perL, true);
  end;

  print;
End.
