{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}

Program Bus;

Const T=59;
      NMax=300;
      MaxRoute=17;
      MaxTime=Round(9*18.2);

Type Times=Set of 0..T;
     O=array[0..T] of Integer;
     TCan=Record
            Span,Numb:Integer;
            Route:Times
          End;

Var N,Min,Cnt,Res,NumP:Integer;
    Go:array[0..NMax] of Integer;
    Can:array[0..T,1..T+1] of TCan;
    Numb:O;
    Sol,SSol:array[1..NMax] of Record
                                 Time,Span:Integer
                               End;
    Count:array[0..T] of Integer;
    S:Times;
    SortR:array[1..NMax] of Integer;
    Time:Longint absolute $0000:$046C;
    breakTime : Longint;
    Succ:array[0..T,1..T] of Integer;
    Pair:array[0..T-1] of Integer;

Procedure Init;
Var i:Integer;
    TT:array[0..T] of Boolean;

  Procedure FillCan;
  Var i,j,k,Gop:Integer;
      S:Times;
  Begin
    FillChar(Can,SizeOf(Can),0);
    FillChar(Count,SizeOf(Count),0);
    For i:=0 to Go[N]-1 do   (*  ⠬ *)
      For j:=i+1 to Go[N] do (*   ⠬ *)
        If (2*i-j<0) or not TT[2*i-j] then
              (*    *)
            Begin
              k:=1;
              S:=[];
              Gop:=j-i;
              While (i+k*Gop<=Go[N]) and TT[i+k*Gop] do
                 (* ᬮ   *)
                Begin
                  Include(S,i+k*Gop);
                  inc(k)
                End;

              If i+k*Gop>Go[N] then (* ᫨ 室 *)
                Begin
                  Inc(Count[i]); (* 稢 - . *)
                  Can[i,Count[i]].Span:=Gop;
                  Can[i,Count[i]].Route:=S;
                  Can[i,Count[i]].Numb:=
                    (Go[N]-i) div Gop+1
                End
            End;
  End(*FillCan*);

  Procedure FillSortR;
  Var i,j,t:Integer;
  Begin
    FillChar(SortR,SizeOf(SortR),0);
    For i:=1 to N do
      SortR[i]:=i;

    For i:=1 to N-1 do
      For j:=i+1 to N do
        If Can[Go[SortR[i]],1].Numb<Can[Go[SortR[j]],1].Numb then
          Begin
            t:=SortR[i];
            SortR[i]:=SortR[j];
            SortR[j]:=t
          End;
  End(*FillSortR*);

  Procedure SortCan;
  Var i,j,k:Integer;
      T1:TCan;
  Begin
    For i:=0 to T-1 do            (*  ⠬ *)
      For j:=1 to Count[i]-1 do   (*  ⠬ *)
        For k:=j+1 to Count[i] do
          If Can[i,j].Numb<Can[i,k].Numb then
            Begin
              T1:=Can[i,j];
              Can[i,j]:=Can[i,k];
              Can[i,k]:=T1
            End;
  End(*SortCan*);

  Procedure FillSucc;
  Var i,j,k:Integer;
  Begin
    FillChar(Succ,SizeOf(Succ),0);
    For i:=0 to T-1 do    (*  ⠬ *)
      If Count[i]<>0 then (* - ਥ *)
        Begin
          j:=1;
          k:=1;
          While k<=Count[i] do
            Begin
              k:=j+1;
              While (k<=Count[i]) and (* . - ⮢ *)
                    (Can[i,j].Numb=Can[i,k].Numb) do
                inc(k);
              Succ[i,Can[i,j].Numb]:=k;
              j:=k
            End
        End;
  End(*FillSuc*);

  Procedure FillPair;
  Var i,j:Integer;
  Begin
    For i:=0 to T-1 do        (*  ⠬ *)
      For j:=1 to Count[i] do (*  ⠬ *)
        If (Can[i,j].Numb=2) and (i-Can[i,j].Span<0) and 
           (2*(i+Can[i,j].Span)-i>59) then
          (* ""  *)
          Begin
            Pair[i]:=j;
            Break
          End
  End(*FillPair*);

Begin
  Assign(input,'input.txt');   ReSet(input);
  Assign(output,'output.txt'); ReWrite(output);

  Read(N);
  FillChar(Go,SizeOf(Go),0);
  Go[0]:=-1;
  FillChar(TT,SizeOf(TT),False);
  FillChar(Numb,SizeOf(Numb),0);
  For i:=1 to N do
    Begin
      Read(Go[i]);
      TT[Go[i]]:=true;  (*  ६ G[i] 襫 ⮡ *)
      Inc(Numb[Go[i]]);
    End;

  FillCan; SortCan;
  FillSucc;
  FillPair;
  FillSortR;
  Cnt:=0;          (* -  ⮢ *)
  Min:=MaxRoute+1; (* 쭮 - ⮢ *)
  S:=[];           (*    *)
  Res:=N;          (* - ⮡ᮢ,  㦭  *)
  NumP:=0;         (* -  ""  *)
  breakTime := Time + maxTime;
End(*Init*);

Procedure Change(Down,Span:Integer);
Var i:integer;
Begin
  For i:=0 to (Go[N]-Go[Down]) div Span do (*  ਡ *)
    Begin
      Dec(Numb[Go[Down]+i*Span]);
      If Numb[Go[Down]+i*Span]=0 then
        Include(S,Go[Down]+i*Span);
    End;
  Dec(Res,(Go[N]-Go[Down]) div Span+1)
End(*Change*);

Function NeedRoute(Res,K,Down:Integer):Integer;
Var i,j,Cnt,Route:integer;
Label Ex;
Begin
  Route:=0;
  Cnt:=0;
  For i:=1 to Numb[Go[K]] do
    Begin
      Inc(Route);
      Inc(Cnt,Can[Go[k],Down].Numb);
    End;

  If Cnt<Res then
    For i:=1 to N do
      If SortR[i]>K then
        For j:=1 to Numb[Go[SortR[i]]] do
          Begin
            Inc(Route);
            Inc(Cnt,Can[Go[SortR[i]],1].Numb);
            If Cnt>=Res then
              Goto Ex
          End;

  Ex: NeedRoute:=Route
End(*NeedRoute*);

Var Fl:boolean;
    KK:integer;

Procedure Pairs;
Var i,j,k,Cnt_:Integer;
Begin
  k:=1;
  Cnt_:=Cnt;
  Repeat
    While (k<=N) and (Numb[Go[k]]=0) do
      (*    *)
      Inc(k);

    If k>N then
      Begin
        If Res=0 then (*  﫨 *)
          Begin
            SSol:=Sol;
            Min:=Cnt;
            Cnt:=Cnt_;
            Exit
          End
      End;

    i:=Pair[Go[k]];
    If i=0 then
      Begin
        Cnt:=Cnt_;
        Exit
      End;

    While (i<=Count[Go[k]]) and (* 饬  室  *)
          (Numb[Go[k]+Can[Go[k],i].Span]=0) do
      Inc(i);

    If i>Count[Go[k]] then (*  諨 *)
      Begin
        Cnt:=Cnt_;
        Exit
      End;

    Inc(Cnt);                           (* 塞 ६ *)
    Sol[Cnt].Time:=Go[k];
    Sol[Cnt].Span:=Can[Go[k],i].Span;
    Dec(Numb[Go[k]]);
    Dec(Numb[Go[k]+Can[Go[k],i].Span]);
    Dec(Res,2)
  Until False
End(*Pairs*);

Procedure Solve(k,pred:integer);
Var Numb_:O;
    S_:Times;
    i,Res_,Down:Integer;
Begin
  If Time>=breakTime then Exit; (* 祭  ६ *)

  If Res<=2*NumP then (* 㦭   *)
    Begin
      If (Res=2*Nump) and {? ->} (Cnt+NumP<Min) then
        (* ᫨       *)
        Pairs
      Else
        If Res=0 then (* 﫨  *)
          Begin
            SSol:=Sol;
            Min:=Cnt
          End;
      Exit;
    End;

  i:=k;
  While (k<=N) and (Numb[Go[k]]=0) do (*  ᢮  *)
    inc(k);

  If k>N then (*  諨 *)
    Exit;

  If Go[k]=Go[i-1] then (*    稭 ॡ *)
    Down:=Pred
  Else
    Down:=1;

  Numb_:=Numb; (*  ६ *)
  S_:=S;
  Res_:=Res;
  Fl:=False;
  Inc(Cnt);
  i:=Down;
  While i<=Count[Go[k]] do (*  ⠬ *)
    Begin
      If (i=Down) or (Can[Go[k],i].Numb<>Can[Go[k],i-1].Numb) then
        If Cnt+NumP+NeedRoute(Res-2*NumP,k,i)-1>=Min then
           Begin
             Dec(Cnt);
             If i=Down then (* ࠧ 뫥⥫ *)
               Begin
                 Fl:=true;
                 KK:=K
               End;
             Exit
           End;

      If i=Pair[Go[k]] then (* 砫 "訥"  *)
        Begin
          inc(NumP);
          Dec(Cnt);
          Solve(k+1,i);
          dec(NumP);
          Exit
        End;

      If S*Can[Go[k],i].Route=[] then (*     *)
        Begin
          Sol[Cnt].Time:=Go[k];             (*   *)
          Sol[Cnt].Span:=Can[Go[k],i].Span;
          Change(k,Can[Go[k],i].Span);
          Solve(k+1,i);
          S:=S_;
          Numb:=Numb_;
          Res:=Res_;
          If Fl and (Go[KK]<Go[k]+Can[Go[k],i].Span) then
            Begin
              i:=Succ[Go[k],Can[Go[k],i].Numb]-1;
              Fl:=False
            End
        End;
      inc(i)
    End;
  Dec(Cnt)
End(*Solve*);

Procedure Done;
Var i:Integer;
    L:Longint;
Begin
  For i:=1 to Min do
    Writeln(SSol[i].Time,' ',SSol[i].Span);

  Close(input);
  Close(output);
End(*Done*);

BEGIN
  Init;
  Solve(1,0);
  Done
END.
