{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

const
  nMax = 100;
  eps = 1e-8;

type
  tWeight = array[1..nMax, 1..nMax] of real;

var
  time, gain, graph : ^tWeight;
  mdl : array[1..nMax, 1..nMax] of byte;
  conn : array[1..nMax, 1..nMax] of boolean;
  N : integer;

procedure Init;
var
  i, left, right, M : integer;
begin
  assign(input, 'input.txt');
  reSet(input);
  assign(output, 'output.txt');
  reWrite(output);

  fillChar(conn, sizeOf(conn), 0);
  new(time); new(gain); new(graph);

  read(N, M);
  for i := 1 to M do begin
    read(left, right);
    read(time^[left, right], gain^[left, right]);
    conn[left, right] := true;
  end;
end;

function Eq(a, b : real) : boolean;
begin
  Eq := abs(a-b) < eps;
end;

procedure out(i, j : integer);
begin
  if mdl[i, j] = 0 then
    write(j, ' ')
  else begin
    out(i, mdl[i, j]);
    out(mdl[i, j], j);
  end;
end;

procedure print(k : integer; gain : real);
var
  i, j : integer;
begin
  writeLn(gain:0:8);
  write(k, ' ');
  out(k, mdl[k, k]); out(mdl[k, k], k);
end;

procedure solve;
var
  down, up, middle : real;
  i, j, k : integer;
  more0, finish : boolean;
label 1;
begin
  down := 0; up := 1e28;
  finish := false;

  repeat
    middle := (up+down)/2;
    for i := 1 to N do
      for j := 1 to N do
        if conn[i, j] then begin
          graph^[i, j] :=gain^[i, j]-middle*time^[i, j];
          if abs(graph^[i, j]) < eps then
            graph^[i, j] := 0;
        end
        else
          graph^[i, j] := -1e28;
    fillChar(mdl, sizeOf(mdl), 0);

    more0 := false;
    for k := 1 to n do
      for i := 1 to n do
        for j := 1 to n do begin
          if graph^[i, j] < graph^[i, k]+graph^[k, j] then begin
            graph^[i, j] := graph^[i, k]+graph^[k, j];
            if (k <> i) and (k <> j) then
              mdl[i, j] := k;
          end;
          if (i = j) and (graph^[i, j] > 0) then begin
            more0 := true;
            goto 1;
          end;
        end;

1:  if more0 then
      down := middle
    else begin
      i := 1;
      while (i <= N) and not Eq(graph^[i, i],0) do
        inc(i);
      if i <= N then begin
        print(i, middle);
        finish := true;
      end
      else
        up := middle;
    end;
  until finish;
end;

Begin
  Init;
  Solve;
End.
