{ Generally fixed }

{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 63384,0,655360}

program Typiki;

type TLexema = (_add, _sub, _mul, _div, _eq, _lt, _gt, _le, _ge, _ne,
                _const, _ident, _EOF, _tz, _packed, _Sopen, _Sclose,
                _fopen, _FClose, _open, _close, _sconst, _buck, _colon,
                _2points, _point, _comma, _SizeInBytes, _SizeInBits, _enum,
                _or, _xor, _and, _in, _Mod, _IDiv, _shl, _shr,
                _num, _false, _true, _file, _high, _low, _abs, _round,
                _trunc, _pi, _odd, _not, _maxint, _maxlongint,
                _real, _double, _single, _extended, _comp, _system,
                _hi, _lo, _swap, _nil, _ptr,
                _ord, _chr, _length, _pred, _succ, _ref,
                _type, _def, {_queries, }_array, _record, _end, _sizeof,
                _input, _output, _of, _set, _string, _byte, _char, _word,
                _integer, _ShortInt, _longint, _boolean, _wordBool, _LongBool);

const EOF = #255;
      MaxTypes = 1024;
      MaxConsts = 1024;

type Tit = record
             typ: TLexema;
             val: Extended;
             st: set of byte;
            str: string;
           end;

     TIdent = string [64];
     TConst = longint; { Fixed! }
     PIdent = ^TIdent;
     PTypeDef = ^TTypeDef;
     TTypeTyp = TLexema;
     PRecFields = ^TRecFields;
     TCaseFields = record
                     n: integer;
                     r: array [1..100] of PTypeDef;
                   end;
     PCaseFields = ^TCaseFields;
     TRecFields = record
                    n: integer;
                 nams: array [1..1024] of PIdent;
                 typs: array [1..1024] of PTypedef;
              CaseTyp: PTypedef;
              CaseNam: TIdent;
                   cf:  PCaseFields;
                  end;

     TTypeDef = record
                  typ: TTypeTyp;
               Sz, Sb: longint;
               xx, yy: longint;
                 arrt: PtypeDef;
                   gf: PTypeDef;
                   rf: PRecFields;
                   dk: boolean;
                   pt: PTypeDef;
                end;
type TFileBuffer = array [0..4096] of char;
     PFileBuffer = ^TFileBuffer;
     TBytes1 = array [0..64000] of byte;
     PBytes1 = ^TBytes1;

var   CurLex: TLexema;
     Enum: boolean;
     dmp: PBytes1;
     dmpl: word;
     EnumT: PTypeDef;
  OutS, TmpS: string;
    CurIdent: TIdent;
   NeedExit: boolean;
   CurString: string;
    CurConst: TConst;
     CurChar: Char;
     LexFile: file;
     buf: PFileBuffer;
     NoDefined, NoCheck: boolean;
       FSize: longint;
       FRead: longint;
      CurPos: longint;
      Consts: integer;
      CNames: array [1..MaxConsts] of PIdent;
       CType: array [1..MaxConsts] of PTypeDef;
        Cval: array [1..MaxConsts] of longint;
       Names: array [1..MaxTypes] of PIdent;
      TypArr: array [1..MaxTypes] of PTypeDef;
       Types: integer;
  val1, val2: tit;

procedure Error (s: string);
begin
  writeln('Error: ', s);
  close (output);
  halt;
end;

procedure NextChar;
begin
  if CurPos < 4095 then
    begin
      inc (CurPos);
      CurChar := {UPCase}(Buf^[CurPos]);
      exit;
    end;
  CurPos := 0;
  if FSize - FRead >= 4096 then
        begin
          inc (FRead, 4096);
          BlockRead (LexFile, Buf^, 4096);
        end else
        begin
          BlockRead (LexFile, Buf^, FSize - FRead);
          Buf^[FSize-FRead] := EOF;
          FRead := FSize;
        end;
  CurChar := {UpCase} (Buf^[CurPos]);
end;

procedure CheckId (id: TIdent; l: TLexema);
var i: integer;
begin
  if not NoDefined then
  for i := 1 to Types do
    if Names[i]^ = id then exit;
  for i := 1 to Consts do
    if CNames[i]^ = id then exit;
  if CurIdent = id then CurLex := l;
end;

procedure CheckResWords;
begin
  CheckId ('TYPE', _type);
  CheckId ('END', _end);
  if NoCheck then exit;
  CheckId ('SWAP', _swap);
  CheckId ('HI', _hi);
  CheckId ('LO', _lo);
  CheckId ('SYSTEM', _system);
  CheckId ('NIL', _nil);
  CheckId ('PTR', _ptr);
  CheckId ('MAXINT', _maxint);
  CheckId ('MAXLONGINT', _maxlongint);
  CheckId ('NOT', _not);
  CheckId ('PI', _pi);
  CheckId ('ABS', _abs);
  CheckId ('ROUND', _round);
  CheckId ('TRUNC', _trunc);
  CheckId ('HIGH', _high);
  CheckId ('LOW', _low);
  CheckId ('SHL', _shl);
  CheckId ('SHR', _shr);
  CheckId ('MOD', _mod);
  CheckId ('DIV', _Idiv);
  CheckId ('AND', _and);
  CheckId ('XOR', _xor);
  CheckId ('OR', _or);
  CheckId ('IN', _in);
  CheckId ('FALSE', _false);
  CheckId ('TRUE', _true);
  CheckId ('COMP', _comp);
  CheckId ('REAL', _real);
  CheckId ('DOUBLE', _double);
  CheckId ('SINGLE', _single);
  CheckId ('EXTENDED', _extended);
  CheckId ('ODD', _odd);
  CheckId ('PRED', _pred);
  CheckId ('SUCC', _succ);
  CheckId ('ORD', _ord);
  CheckId ('CHR', _chr);
  CheckId ('LENGTH', _length);
  CheckId ('BOOLEAN', _boolean);
  CheckId ('BYTEBOOL', _boolean);
  CheckId ('WORDBOOL', _WordBool);
  CheckId ('LONGBOOL', _LongBool);
  CheckId ('BYTE', _byte);
  CheckId ('WORD', _word);
  CheckId ('CHAR', _char);
  CheckId ('STRING', _string);
  CheckId ('DEFINITIONS', _def);
  CheckId ('ARRAY', _array);
  CheckId ('RECORD', _record);
  CheckId ('SIZEOF', _sizeof);
  CheckId ('INPUT', _input);
  CheckId ('OUTPUT', _input);
  CheckId ('TEXT', _input);
  CheckId ('FILE', _file);
  CheckId ('OF', _of);
  CheckId ('SET', _set);
  CheckId ('INTEGER', _integer);
  CheckId ('SHORTINT', _shortint);
  CheckId ('LONGINT', _longint);
  CheckId ('RANDSEED', _longint);
  CheckId ('SEGA000', _word);
  CheckId ('SEGB000', _word);
  CheckId ('PACKED', _packed);
  CheckId ('SIZEINBYTES', _SizeInbytes);
  CheckId ('SIZEINBITS', _SizeInbits);
  if CurLex = _nil then
    begin
      CurLex := _Const; CurConst := 0;
    end;
  if CurLex = _maxint then
    begin
      CurLex := _Const; CurConst := 32767;
    end;
  if CurLex = _maxlongint then
    begin
      CurLex := _Const; CurConst := 2147483647;
    end;
end;

procedure next; Forward;

function ReadIntI: longint;
var l: longint;
begin
  if CurLex = _const then
       begin
         ReadIntI := CurConst;
         exit;
       end;
  if CurLex = _Buck then
    begin
      l := 0;
      while UpCase(CurChar) in ['0'..'9','A'..'Z'] do
      begin
        l := l * 16;
        if curchar < '9' then l := l + byte (CurChar) - 48 else
          l := l + Byte (UpCase(CurChar)) - 55;
        nextChar;
      end;
      ReadIntI := l;
    end;
end;

function ReadInt: longint;
var l: longint;
begin
  if CurLex = _const then
       begin
         ReadInt := CurConst;
         next;
         exit;
       end;
  if CurLex = _Buck then
    begin
      l := 0;
      while UpCase(CurChar) in ['0'..'9','A'..'Z'] do
      begin
        l := l * 16;
        if curchar < '9' then l := l + byte (UpCase(CurChar)) - 48 else
          l := l + Byte (UpCase(CurChar)) - 55;
        nextChar;
      end;
      next;
      ReadInt := l;
    end;
end;

function TypeNumber (id: TIdent): integer;
var i: integer;
begin
  for i := 1 to Types do
   if names[i]^ = id then begin TypeNumber := i; exit; end;
  TypeNumber := 0;
end;

function TypeNumberP (p: PTypeDef): integer;
var i: integer;
begin
  for i := 1 to Types do
   if typarr[i] = p then begin TypeNumberP := i; exit; end;
  TypeNumberP := 0;
end;

procedure Next;
var i: byte;
 last: byte;
begin
  while CurChar <= #32 do nextchar;
  case UpCase(CurChar) of
   EOF: begin CurLex := _EOF; exit; end;
   '{': begin
          while curchar <> '}' do nextchar;
          nextchar;
          next;
        end;
  '''','#','^': begin
          CurLex := _SConst;
          CurString := '';
          last := 1;
          while CurChar in ['#','''','^'] do
          begin
            if CurChar = '''' then
             begin
               if last = 0 then CurString := CurString + '''';
               last := 0;
               NextChar;
               while CurChar <> '''' do
               begin
                 CurString := CurString + CurChar;
                 NextChar;
               end;
               nextChar;
             end;
            if CurChar = '#' then
            begin
              last := 1;
              NextChar;next;
              i := ReadIntI;
              CurString := CurString + char (i);
            end;
            if CurChar = '^' then
            begin
              last := 1;
              NextChar;
              CurString := CurString + char (byte(UpCase(CurChar))-64);
              nextchar;
            end;
          end;
          CurLex := _SConst; {Fixed!}
        end;
   ',': begin
          CurLex := _Comma;
          NextChar;
        end;
   '$': begin
          CurLex := _Buck;
          NextChar;
        end;
   '.': begin
          CurLex := _Point;
          NextChar;
          if CurChar = '.' then begin nextchar; CurLex := _2points; end;
          if CurChar = ')' then begin CurLex := _SClose; NextChar; end;
        end;
   ':': begin
          CurLex := _Colon;
          NextChar;
        end;
   '{': begin
          CurLex := _FOpen;
          NextChar;
        end;
   '}': begin
          CurLex := _FClose;
          NextChar;
        end;
   '[': begin
          CurLex := _SOpen;
          NextChar;
        end;
   ']': begin
          CurLex := _SClose;
          NextChar;
        end;
   '(': begin
          CurLex := _Open;
          NextChar;
          if CurChar = '.' then begin CurLex := _Sopen; NextChar; end;
          if CurChar = '*' then
            begin
              nextChar;
              repeat
                while CurChar <> '*' do nextchar;
                nextchar;
              until CurChar = ')';
              NextChar;
              next;
            end;
        end;
   ')': begin
          CurLex := _Close;
          NextChar;
        end;
   ';': begin
          CurLex := _tz;
          NextChar;
        end;
   '+': begin
          CurLex := _add;
          NextChar;
        end;
   '-': begin
          CurLex := _sub;
          NextChar;
        end;
   '*': begin
          CurLex := _mul;
          NextChar;
        end;
   '/': begin
          CurLex := _div;
          NextChar;
        end;
   '=': begin
          CurLex := _eq;
          NextChar;
        end;
   '<': begin
          NextChar;
          if CurChar = '=' then CurLex := _le else
          if CurChar = '>' then CurLex := _ne else
                                CurLex := _lt;
          if CurLex <> _lt then NextChar;
        end;
   '>': begin
          NextChar;
          if CurChar = '=' then CurLex := _ge else
                                CurLex := _gt;
          if CurLex <> _gt then NextChar;
        end;
'0'..'9': begin
            CurLex := _Const;
            CurConst := 0;
            while CurChar in ['0'..'9'] do
            begin
              CurConst := CurConst * 10 + byte(CurChar) - $30;
              NextChar;
            end;
          end;
'A'..'Z','_':
          begin
            CurLex := _Ident;
            CurIdent := UpCase(CurChar);
            NextChar;
            while UpCase(CurChar) in ['0'..'9', 'A'..'Z', '_'] do
            begin
              if length (CurIdent) < 63 then
                 CurIdent := CurIdent + UpCase(CurChar);
              NextChar;
            end;
            CheckResWords;
          end;
   else Error ('Unknow character');
  end;
  if CurLex = _System then
   begin
     noDefined := true;
     next;next;
     noDefined := false;
   end;
end;

procedure Expected (l: TLexema);
begin
  if CurLex <> l then Error('Something else expected.');
end;

procedure LexInit;
begin
  NoCheck := false;
  New (buf);
  assign (LexFile, 'input.txt'); reset (LexFile, 1);
  FSize := FileSize (LexFile);
  FRead := 0;
  CurPos := 4095;
  NextChar;
  Next;
end;

procedure NewTypeDef (var P: PTypeDef);
begin
  new (p);
  p^.typ := _byte;
  p^.pt := nil;
  p^.gf := nil;
  p^.rf := nil;
end;

procedure NewRecFields (var P: PRecFields);
begin
  new (p);
  p^.n := 0;
  p^.CaseTyp := nil;
  p^.caseNam := '';
  p^.Cf := nil;
end;

function Log2 (a: longint): integer;
var i: integer;
begin
  dec (a);
  i := 0;
  while (a > 0) do begin a := a shr 1; inc (i); end;
  Log2 := i;
end;

procedure ReadTypeDef (var p: PTypeDef);  forward;
procedure ConstExpr(var a: tit); forward;
function FindConstN (p: TIdent): integer;
var i: integer;
begin
  for i := 1 to Consts do
  if (CNames[i]^ = p) then
    begin
      FindConstN := i;
      exit;
    end;
  FindConstN := 0;
end;


var mn: extended;
    lala, lala1: integer;
    tmptyp, tmptyp1: PTypeDef;
    g: tit;

procedure ParseFactor(var a: tit);
var i: integer;
   sl: tlexema;
begin
  case CurLex of
 _system: begin
            next;next;
            ParseFactor (a); { Fixed! }
          end;

 _sub: begin
         next;
         ParseFactor (a);
         a.val := -a.val;
       end;
 _add: begin  { Fixed! }
         next;
         ParseFactor (a);
       end;
 _not: begin
         next;
         ParseFactor (a);
         if a.typ = _Boolean then
             a.val := byte(not boolean (round(a.val))) else
             a.val := longint(not longint(round(a.val)));
       end;
 _Sopen: begin { Set! }
           a.typ := _set;
           a.st := [];
           next;
           while CurLex <> _SClose do
           begin
             Enum := false;
             ConstExpr (val1);
             if val1.typ = _string then lala := byte(val1.str[1])
                                   else lala := round(val1.val);
             if CurLex = _2Points then
              begin
                next;
                Enum := false;
                ConstExpr (val1);
                if val1.typ = _string then lala1 := byte(val1.str[1])
                                      else lala1 := round(val1.val);
              end else lala1 := lala;
             for lala := lala to lala1 do
               a.st := a.st + [lala];
             if CurLex = _comma then Next;
           end;
           next;
         end;
 _byte, _integer, _word, _Longint, _shortint:
        begin
           sl := CurLex;
           next;
           next;
             ConstExpr (a);
             if a.typ =  _string then a.val := byte(a.str[1]);
            a. typ := _num;
            case sl of
              _byte: a.val := byte (round(a.val));
              _word: a.val := word (round(a.val));
           _integer: a.val := integer (round(a.val));
           _longint: a.val := longint (round(a.val));
          _shortint: a.val := shortint (round(a.val));
            end;
           next;
        end;
 _char: begin
           next;
           next;
             ConstExpr (a);
             if a.typ =  _string then a.val := byte(a.str[1]);
             a. typ := _char;
           next;
        end;
 _boolean, _longbool, _wordbool: begin
           next;
           next;
             ConstExpr (a);
             if a.typ =  _string then a.val := byte(a.str[1]);
             a. typ := _boolean;
           next;
        end;
 _ident: begin
           i := TypeNumber (CurIdent);
           if i = 0 then
             begin { Constant }
                i := FindConstN (CurIdent);
                enum := true;
                EnumT := Ctype[i];
                a.typ := _num;
                a.val := CVal[i];
                next;
                exit;
             end;
           if typarr[i]^.typ in [_byte, _integer, _word, _Longint, _shortint,
                                 _enum]
             then
              begin
               sl := typarr[i]^.typ;
               next;
               next;
               ConstExpr (a);
               if a.typ =  _string then a.val := byte(a.str[1]);
               a. typ := _num;
               case sl of
                _byte: a.val := byte (round(a.val));
                _word: a.val := word (round(a.val));
             _integer: a.val := integer (round(a.val));
             _longint: a.val := longint (round(a.val));
            _shortint: a.val := shortint (round(a.val));
                _enum: begin
                         Enum := true;
                         EnumT := typarr[i];
                       end;
               end;
               next;
              end else
           if typarr[i]^.typ = _Char then
              begin
                next;
                next;
                ConstExpr (a);
                if a.typ =  _string then a.val := byte(a.str[1]);
                a. typ := _char;
                next;
              end else
           if typarr[i]^.typ in [_boolean, _longbool, _wordbool] then
             begin
               next;
               next;
               ConstExpr (a);
               if a.typ =  _string then a.val := byte(a.str[1]);
               a. typ := _boolean;
               next;
             end else Error('Sorry!');
         end;
 _sconst: begin
            a. typ := _string;
            a.str := CurString;
            next;
          end;
   _open: begin
            next;
            ConstExpr (a);
            next;
          end;
   _odd: begin
           next;
           next;
             ConstExpr (a);
             if odd(round(a.val)) then a.val := 1 else a.val := 0;
             a.typ := _boolean;
           next;
         end;
  _Succ: begin
           next;
           next;
             ConstExpr (a);
             if a.typ = _string then a.str[1] := Succ(a.str[1]) else
             if a.typ = _boolean then a.val :=
                     byte(Succ(boolean(round(a.val)))) else
                a. val := a.val +1;
             a.typ := _boolean;
           next;
         end;
  _pred: begin
           next;
           next;
             ConstExpr (a);
             if a.typ = _string then a.str[1] := pred(a.str[1]) else
             if a.typ = _boolean then a.val :=
                   byte(pred(boolean(round(a.val)))) else
                a. val := a.val -1;
             a.typ := _boolean;
           next;
         end;
   _ord: begin
           next;
           next;
             ConstExpr (a);
             Enum := false;
             if a.typ = _string then a.val := byte(a.str[1]);
             a.typ := _num;
           next;
         end;
    _pi: begin
           next;
           a. typ := _num;
           a. val := pi;
         end;
_Length: begin
           next;
           next;
             ConstExpr (a);
             if a.typ = _string then a.val := length (a.str);
             a.typ := _num;
           next;
         end;
_hi: begin
       next;
       next;
       ConstExpr (a);
       a.val := hi(round(a.val));
       next;
     end;
_ptr: begin
       next;
       next;
       ConstExpr (a);
       next;
       ConstExpr (g);
       a.val := longint(ptr(round(a.val),round(g.val)));
       next;
     end;
_lo: begin
       next;
       next;
       ConstExpr (a);
       a.val := lo(round(a.val));
       next;
     end;
_swap: begin
       next;
       next;
       ConstExpr (a);
       a.val := swap(round(a.val));
       next;
     end;
_abs, _round, _trunc:
         begin
           sl := CurLex;
           next;
           next;
             ConstExpr (a);
             if sl = _abs then a.val := abs (a.val);
             if sl = _round then a.val := round (a.val);
             if sl = _trunc then a.val := trunc (a.val);
           next;
         end;
_chr, _char:
         begin
           next;
           next;
             ConstExpr (a);
             if a.typ <> _string then
               begin
                 a. typ := _string;
                 a. str[0] := #1;
                 a. str[1] := char (round(a.val));
               end;
           next;
         end;
   _High: begin
              next;
              next;
              a.typ := _num;
                  ReadTypeDef (TmpTyp);
                  a.val := tmptyp^.yy;
                  if tmptyp^.typ in [_boolean, _char]
                     then a.typ := tmptyp^.typ;
                  if tmptyp^.dk = false then dispose (tmptyp);
              next;
            end;
    _Low: begin
              next;
              next;
              a.typ := _num;
                  ReadTypeDef (TmpTyp);
                  a.val := tmptyp^.xx;
                  if tmptyp^.typ in [_boolean, _char]
                     then a.typ := tmptyp^.typ;
                  if tmptyp^.dk = false then dispose (tmptyp);
              next;
            end;
   _sizeof: begin
              next;
              next;
              a.typ := _num;
              if CurLex = _input then begin a.val := 256;next;end else
              if CurLex = _file then begin a.val := 128;next;end else
                begin
                  ReadTypeDef (TmpTyp);
                  a.val := tmptyp^.sz;
                  if tmptyp^.dk = false then dispose (tmptyp);
                end;
              next;
            end;
   _false: begin
             a.typ := _boolean;
             a.val := 0;
             next;
           end;
    _true: begin
             a.typ := _boolean;
             a.val := 1;
             next;
           end;
    _buck: begin
             a.typ := _num;
             a.val := ReadInt;
           end;
   _const: begin
             a.typ := _num;
             a.val := ReadInt;
             if Curlex = _point then
               begin
                 mn := 1;
                 while CurChar <= #32 do NextChar;
                 while CurChar in ['0'..'9'] do
                 begin
                   mn := mn * 0.1;
                   a.val := a.val + mn * (byte(CurChar) - 48);
                   nextchar;
                 end;
                 while CurChar <= #32 do NextChar;
                 if UpCase(CurChar) = 'E' then
                      begin
                        nextchar;
                        while CurChar <= #32 do NextChar;
                        mn := 10;
                        if CurChar = '+' then nextchar else
                        if CurChar = '-' then begin mn := 0.1; nextchar;end;
                        next;
                        lala := ReadInt;
                        for i := 1 to lala do
                          a.val := a.val * mn;
                      end;
                 next;
               end;
           end;
  end;
end;

procedure ParseTerm(var a: tit);
var h: tit;
    SaveLex: TLexema;
begin
  ParseFactor (a);
  while curlex in [_Mul, _Div,  _IDiv, _Mod, _and, _shl, _shr] do
  begin
    SaveLex := CurLex;
    next;
    ParseFactor (h);
    case SaveLex of
      _shl:begin
             while h.val > 0.1 do begin a.val := a.val * 2;
                                        h.val := h.val-1;end;
           end;
      _shr:begin
             while h.val > 0.1 do begin a.val := a.val / 2;
                                        a.val := a.val - frac (a.val);
                                        h.val := h.val-1;end;
           end;
      _mul:begin
             if a.typ = _num then a.val := a.val * h.val;
             if a.typ = _set then a.st := a.st * h.st;
           end;
      _div: a.val := a.val / h.val;
     _Idiv: a.val := trunc (a.val / h.val);
     _Mod:  a.val := a.val - trunc (a.val / h.val);
     _and: if a.typ = _boolean then
           a.val := byte(boolean(round (a.val)) and boolean(round (h.val))) else
           a.val := round (a.val) and round (h.val);
    end;
  end;
end;

procedure ToString (var a: tit);
begin
  if a.typ = _string then exit;
  a.typ := _string;
  a.str[0] := #1;
  a.str[1] := char (round(a.val));
end;

procedure ParseExpr(var a: tit);
var h: tit;
    SaveLex: TLexema;
begin
  ParseTerm (a);
  while curlex in [_sub, _add, _or, _xor] do
  begin
    SaveLex := CurLex;
    next;
    ParseTerm (h);
    case SaveLex of
      _sub:begin
             if a.typ = _num then a.val := a.val - h.val;
             if a.typ = _set then a.st := a.st - h.st;
           end;
      _add:begin
             if a.typ = _num then a.val := a.val + h.val;
             if a.typ = _set then a.st := a.st + h.st;
             if a.typ in [_Char, _string] then
                  begin
                    ToString (a);
                    ToString (h);
                    a.str := a.str + h.str;
                  end;
           end;
     _or: if a.typ = _boolean then
           a.val := byte(boolean(round (a.val)) or boolean(round (h.val))) else
           a.val := round (a.val) or round (h.val);
     _xor: if a.typ = _boolean then
           a.val := byte(boolean(round (a.val)) xor boolean(round (h.val))) else
           a.val := round (a.val) xor round (h.val);
    end;
  end;
end;

procedure ConstExpr(var a: tit);
var h: tit;
    SaveLex: TLexema;
begin
  ParseExpr (a);
  while curlex in [_lt, _gt, _le, _ge, _ne, _eq, _in] do
  begin
    SaveLex := CurLex;
    next;
    ParseExpr (h);
    case SaveLex of
      _lt:begin
            if a.typ in [_num, _char] then if a.val < h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str < h.str then a.val := 1 else a.val := 0;
          end;
      _le:begin
            if a.typ in [_num, _char] then if a.val <= h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str <= h.str then a.val := 1 else a.val := 0;
          end;
      _gt:begin
            if a.typ in [_num, _char] then if a.val > h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str > h.str then a.val := 1 else a.val := 0;
          end;
      _ge:begin
            if a.typ in [_num, _char] then if a.val >= h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str >= h.str then a.val := 1 else a.val := 0;
          end;
      _ne:begin
            if a.typ in [_num, _char] then if a.val <> h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str <> h.str then a.val := 1 else a.val := 0 else
            if (a.typ = _set) then if a.st <> h.st then a.val := 1 else a.val := 0;
          end;
      _eq:begin
            if a.typ in [_num, _char] then if a.val = h.val then a.val := 1 else a.val := 0 else
            if (a.typ = _string) then if a.str = h.str then a.val := 1 else a.val := 0 else
            if (a.typ = _set) then if a.st = h.st then a.val := 1 else a.val := 0;
          end;
      _in: begin
            if a.typ in [_num, _char] then
               if round (a.val) in h.st then a.val := 1 else a.val := 0 else
            if a.typ = _string then
               if byte (a.str[1]) in h.st then a.val := 1 else a.val := 0 else
           end;
    end;
    a.typ := _boolean;
  end;
end;

procedure ReadArrayTail (var P: PTypeDef);
var tmp: PTypeDef;
begin
  if CurLex = _SClose then
       begin
         next; {]};
         next; { of }
         ReadTypeDef (p);
         exit;
       end;
  NewTypeDef (p);
  ReadTypeDef (tmp);
  p^.xx := tmp^.xx;
  p^.yy := tmp^.yy;
  p^.Arrt := tmp;
  if CurLex = _Comma then Next;
  ReadArrayTail (p^.gf);
  p^.sz := (p^.yy-p^.xx+1) * p^.gf^.sz;
  p^.sb := (p^.yy-p^.xx+1) * p^.gf^.sb;
  p^.typ := _Array;
end;

procedure ReadRecDef (var p: PTypeDef);
var i, cr: integer;
begin
  NewTypeDef (p);
  p^.typ := _record;
  with p^ do
  begin

             p^.sb := 0;
             p^.sz := 0;
             NoCheck := true;
             NewRecFields (p^.rf);
             while CurLex = _tz do next;
             NoCheck := false;
             with p^.rf^ do
               while curlex <> _close do
               begin
                 cr := n;
                 while CurLex <> _Colon do
                 begin
                   inc (n);
                   new (nams [n]);
                   nams[n]^ := CurIdent;
                   NoCheck := true;
                   next; {Ident}
                   if CurLex = _Comma then next;
                   NoCheck := false;
                 end;
                 next; {:}
                 ReadTypeDef (typs[n]);
                 p^.sz := p^.sz + Typs[n]^.sz * (n-cr);
                 p^.sb := p^.sb + Typs[n]^.sb * (n-cr);
                 for i := cr + 1 to n-1 do typs[i] := typs[n];
                 while CurLex = _tz do next;
               end;
             next;
   end;
end;


procedure ReadTypeDef (var p: PTypeDef);
var mxb, mxz, ss: longint;
    i, cr: integer;
    lb, rb: byte;
    fe: boolean;
    val1: tit;
begin
  while CurLex = _Packed do next;
  NewTypeDef (p);
  case CurLex of
_boolean: with p^ do
           begin
             typ := CurLex;
             sz := 1;
             sb := 1;
             xx := 0;
             yy := 1;
             next;
           end;
_WordBool: with p^ do
           begin
             typ := _Boolean;
             sz := 2;
             sb := 1;
             xx := 0;
             yy := 1;
             next;
           end;
_LongBool: with p^ do
           begin
             typ := _Boolean;
             sz := 4;
             sb := 1;
             xx := 0;
             yy := 1;
             next;
           end;
    _byte: with p^ do
           begin
             typ := CurLex;
             sz := 1;
             sb := 8;
             xx := 0;
             yy := 255;
             next;
           end;
_Single: with p^ do
           begin
             typ := CurLex;
             sz := 4;
             sb := 32;
             xx := 0;
             yy := 255;
             next;
           end;
_Double: with p^ do
           begin
             typ := CurLex;
             sz := 8;
             sb := 64;
             xx := 0;
             yy := 255;
             next;
           end;
 _Real: with p^ do
           begin
             typ := CurLex;
             sz := 6;
             sb := 48;
             xx := 0;
             yy := 255;
             next;
           end;
_Extended: with p^ do
           begin
             typ := CurLex;
             sz := 10;
             sb := 80;
             xx := 0;
             yy := 255;
             next;
           end;
   _Comp: with p^ do
           begin
             typ := CurLex;
             sz := 8;
             sb := 64;
             xx := 0;
             yy := 255;
             next;
           end;
    _word: with p^ do
           begin
             typ := CurLex;
             sz := 2;
             sb := 16;
             xx := 0;
             yy := 65536;
             next;
           end;
    _Char: with p^ do
           begin
             typ := CurLex;
             sz := 1;
             sb := 8;
             xx := 0;
             yy := 255;
             next;
           end;
_Shortint: with p^ do
           begin
             typ := CurLex;
             sz := 1;
             sb := 8;
             xx := -128;
             yy := 127;
             next;
           end;
 _Longint: with p^ do
           begin
             typ := CurLex;
             sz := 4;
             sb := 32;
             xx := (-2147483647)-1;
             yy := -2147483647;
             next;
           end;
 _Integer: with p^ do
           begin
             typ := CurLex;
             sz := 2;
             sb := 16;
             xx := -32768;
             yy := 32767;
             next;
           end;
  _String: with p^ do
           begin
             typ := CurLex;
             next;
             if CurLex = _Sopen then
                  begin
                    next;
                    ConstExpr (val1);
                    ss := round (val1.val);
                    next;
                  end else ss := 255;
             sz := ss + 1;
             sb := ss * 8 + Log2 (ss+1);
             xx := 0;
             yy := ss;
           end;

  _set: begin
          next;  { set }
          next;  { of }
{          dispose (p);}
          readTypeDef (p^.arrt);
{          new (p^.arrt);}
{          p^.arrt^ := p^;}
          p^.xx := p^.arrt^.xx; { Fixed! }
          p^.yy := p^.arrt^.yy;
          p^.typ := _set;
          p^.sb := (p^.yy-p^.xx+1);
          lb := p^.xx div 8;
          rb := p^.yy div 8;
          p^.sz := (rb-lb) + 1; { Fixed! }
        end;

  _Open: with p^ do
         begin { Enumerated }
           typ := _Enum;
           ss := 0;
           next;
           while CurLex <> _Close do
           begin
             inc (ss);
             inc (Consts);
             new (CNames[Consts]);
             CNames[Consts]^ := CurIdent;
             CVal[Consts] := ss-1;
             CType [Consts] := p;
             next;
             if CurLex = _comma then next;
           end;
           xx := 0;
           yy := ss-1;
           sb := Log2 (ss);
           if ss = 1 then sb := 0;
           if ss < 257 then sz := 1 else sz := 2;
           next;
         end;

  _Ident: with p^ do
          begin
            ss := TypeNumber (CurIdent);
            if ss = 0 then
                   begin
                     ss := FindConstN (CurIdent);
                     p^ := Ctype[ss]^;
                     p^. pt := Ctype[ss];
                     p^.xx := CVal[ss];
                     next;
                     next; {..}

                     Enum := false;
                     ConstExpr (val1);
{                     ss := FindConstN (CurIdent);}
                     p^.yy := round (val1.val);
{                     next;}
                     p^.sb := log2 (p^.yy-p^.xx+1);
                     while CurLex = _tz do next;
                     exit;
                   end;
            dispose (p);
            p := typarr[ss];
            p^.dk := true;
            next;
          end;

  _Array: with p^ do
          begin
            next;
            typ := _Array;
            Expected(_Sopen); next;
            dispose (p);
            ReadArrayTail (p);
          end;

  _record: with p^ do
           begin
             typ := _record;
             p^.sb := 0;
             p^.sz := 0;
             NoCheck := true;
             next;
             NewRecFields (p^.rf);
             while CurLex = _tz do next;
             NoCheck := false;
             with p^.rf^ do
               while curlex <> _end do
               begin
                 if CurIdent = 'CASE' then
                      begin
{---------------------------------------------------------------------------}
                        { Fusssk!!! }
                        next;
                        if CurLex = _Ident then
                           begin
                             CaseNam := CurIdent;
                             next;
                             next;
                           end;
                        ReadTypeDef (CaseTyp);
                        if CaseNam <> '' then
                          begin
                            sb := sb + CaseTyp^.sb;
                            sz := sz + CaseTyp^.sz;
                          end;
                        new (cf);
                        cf^.n := 0;
                        next; { of }
                        mxb := 0; mxz := 0;
                        while CurLex <> _End do
                        begin
                          ConstExpr (val1);
                          next; { Colon }
                          next; { ( };
                          inc (cf^.n);
                          ReadRecDef (cf^.r[cf^.n]);
                          if cf^.r[cf^.n]^.sb > mxb then mxb := cf^.r[cf^.n]^.sb;
                          if cf^.r[cf^.n]^.sz > mxz then mxz := cf^.r[cf^.n]^.sz;
                          while CurLex = _tz do next;
                        end;
                        next;
                        sb := sb + mxb;
                        sz := sz + mxz;
                        while CurLex = _tz do next;
                        exit;
{---------------------------------------------------------------------------}
                      end;
                 cr := n;
                 while CurLex <> _Colon do
                 begin
                   inc (n);
                   new (nams [n]);
                   nams[n]^ := CurIdent;
                   NoCheck := true;
                   next; {Ident}
                   if CurLex = _Comma then next;
                   NoCheck := false;
                 end;
                 next; {:}
                 ReadTypeDef (typs[n]);
                 p^.sz := p^.sz + Typs[n]^.sz * (n-cr);
                 p^.sb := p^.sb + Typs[n]^.sb * (n-cr);
                 for i := cr + 1 to n-1 do typs[i] := typs[n];
                 while CurLex = _tz do next;
               end;
             next;
           end;
 else
{  _Const, _buck, _ord, _length, _pred, _succ, _false, _true, etc.}
  with p^ do
          begin
            fe := false; enum := false;
            ConstExpr (val1);
            fe := fe or enum;
            if val1.typ = _string then
              xx := byte (val1.str[1]) else xx := round (val1.val);
            if enum then val1.typ := _enum;
            Expected (_2points); next;
            Enum := false;
            ConstExpr (val1);
            fe := fe or enum;
            if val1.typ = _string then
              yy := byte (val1.str[1]) else yy := round (val1.val);
            sb := log2 (yy-xx+1);
            if (yy-xx+1 < 0) then sb := 32; { Fixed!}
            if (yy-xx) = MaxLongint then sb := 31;
            typ := _longint; sz := 4;
            if (xx >=0) and (yy <= 65536) then
                begin
                  typ := _word;
                  sz := 2;
                end;
            if (xx >=-32768) and (yy <= 32767) then
                begin
                  typ := _Integer;
                  sz := 2;
                end;
            if (xx >=0) and (yy <= 255) then
                begin
                  typ := _byte;
                  sz := 1;
                end;
            if (xx >=-128) and (yy <= 127) then
                begin
                  typ := _ShortInt;
                  sz := 1;
                end;
            if val1. typ = _boolean then p^.typ := _Boolean;
            if val1. typ = _char then p^.typ := _char;
            if fe then
                 begin
                   p^.typ := _Enum;
                   p^.pt := EnumT;
                 end;
            if val1. typ = _string then p^.typ := _char;
          end;
  end;
  NoCheck := true;
  while CurLex = _tz do next;
  NoCheck := false;
end;

procedure ReadTypeDefinition;
begin
  inc (types);
  new(names [types]);
  Names [types]^ := CurIdent; next;
  if curlex <> _eq then begin needExit := true; exit;end;
  Expected (_eq); next;
  ReadTypeDef (TypArr[Types]);
end;

procedure ReadTypeDefinitions;
begin
  NoCheck := true;
  next;
  NoCheck := false;
  NeedExit := false;
  While (CurLex = _ident) and (not NeedExit) do
    ReadTypeDefinition;
end;

procedure SynInit;
begin
  Types := 0; NoDefined := false;
end;

procedure AnalyzeTypes;
begin
  If CurLex <> _def then Error ('Defs expected.') else next;
  While CurLex = _Type do ReadTypeDefinitions;
end;

function HexByte: byte;
var b, i: byte;

begin
  CurChar := UpCase (CurChar);
  if CurChar <= char ('9') then
      i := byte(CurChar)-byte('0') else i := byte (upCase(CurChar))-55;
  nextchar;
  b := i * 16;
  if CurChar <= char ('9') then
      i := byte(CurChar)-byte('0') else i := byte (upCase(CurChar))-55;
  b := b + i;
  nextchar;
  HexByte := b;
end;

type bytes = array [0..1000] of byte;
     Pbytes = ^bytes;

procedure ReadBytes (var a; n: integer; db: word);
var i: integer;
begin
 Move (dmp^[db], a, n);
end;

procedure OutType (p: PTypeDef; nm: PIdent; db: word); forward;

function FindConst (p: PTypeDef; v: longint): integer;
var i: integer;
begin
  for i := 1 to Consts do
  if (Cval[i] = v) and (Ctype[i] = p) then
    begin
      FindConst := i;
      exit;
    end;
  FindConst := 0;
end;

procedure UpdateTyp (var p: PTypeDef);
begin
  while p^.pt <> nil do p := p^.pt;
end;

procedure OutArrayTail (p: PTypeDef;db:word);
var i, j, k: longint;
    ll: char;
    db1: word;
begin
  db1 := db;
  ll := outs[0];
  if p^.typ <> _array then
        begin
          if outs <> '' then outS := OutS + ']';
          OutType (p, nil, db);
          outs[0] := ll;
          exit;
        end;
  for i := p^.xx to p^.yy do
  begin
    if p^.arrt^.typ = _Char then
      begin
        if Char (i) = #39 then Tmps := #39#39#39#39 else
        TmpS := #39+char (i)+#39;
      end else
    if p^.arrt^.typ = _Boolean then
        begin
          if i mod 256 = 0 then tmps := 'FALSE' else tmps := 'TRUE';
        end else
    if p^.arrt^.typ = _enum then
      begin
        tmptyp1 := p^.arrt;
        UpdateTyp (tmptyp1);
        k := FindConst (tmptyp1, i);
        if k = 0 then
          begin
            Str (i, TmpS);
          end else TmpS := Cnames[k]^;
      end else
      Str (i, TmpS);
    if outs <> '' then outs := outs + tmpS;
    if p^.gf^.typ = _array then if outs<>'' then outs := outs + ',';
    OutArrayTail (p^.gf, db1);
    db1 := db1 + p^.gf^.sz;
    outs[0] := ll;
  end;
end;

var
    tr: real;
    tsin: single;
    Texte: extended;
    tdou: double;
    tcmp: comp;
    tset: array [0..31] of byte;

procedure writeIt(ts: string);
var i: integer;
begin
  for i := 1 to length(ts) do
  if ts[i] = #39 then write(#39,#39) else write(ts[i]);
end;

procedure OutType (p: PTypeDef; nm: PIdent; db: word);
var sl1, sla, j, i, bb, b: byte;
    ti: integer;
    tl: longint;
    db1, tw: word;
    tsi: shortint;
    ts: string;
begin
  if not (p^.typ in [_record, _array]) then
    if nm <> nil then write (outs, nm^, ' = ') else if outs <> ''
     then write (outs, ' = ');
  case p^.typ of
  _String:begin
            ReadBytes (ts, p^.sz, db);
            write ('''');
            writeIt (ts);
            writeln ('''');
          end;
    _Char:begin
            b := dmp^[db];
            if char(b) = '''' then writeln(#39#39#39#39) else
            writeln (#39, char(b),#39);
          end;
    _byte:begin
            b := dmp^[db];
            writeln (b);
          end;
    _word:begin
            ReadBytes (tw, 2, db);
            writeln (tw);
          end;
    _real:begin
            ReadBytes (tr, 6, db);
            writeln (tr);
          end;
  _Single:begin
            ReadBytes (tsin ,4, db);
            writeln (tsin);
          end;
  _Double:begin
            ReadBytes (tdou ,8, db);
            writeln (tdou);
          end;
_Extended:begin
            ReadBytes (texte ,10, db);
            writeln (texte);
          end;
    _Comp:begin
            ReadBytes (tcmp ,8, db);
            writeln (tcmp);
          end;
 _integer:begin
            ReadBytes (ti, 2, db);
            writeln (ti);
          end;
 _Longint:begin
            ReadBytes (tl, 4, db);
            writeln (tl);
          end;
_ShortInt:begin
            ReadBytes (tsi, 1, db);
            writeln (tsi);
          end;
 _enum: begin
          if p^.sz = 1 then tw := dmp^[db] else ReadBytes (tw, 2, db);
          tmptyp1 := p;
          UpdateTyp (tmptyp1);
          ti := FindConst (tmptyp1, tw);
          if ti = 0 then
               writeln (Names[TypeNumberP(p)]^, '(', tw, ')') else
               writeln (CNames[ti]^);
        end;
 _boolean:begin
            b := dmp^[db];
{            for i := 2 to p^.sz do
              bb := Hexbyte;}
            if b = 0 then writeln('FALSE') else writeln ('TRUE');
          end;
 _record: begin
            sla := byte (outs[0]);
            if nm<>nil then outs := outs + nm^;  { Fixed! }
            if p^.rf^.n = 0 then writeln(outs,' = ');
            if outs <> '' then outs := outs + '.';
            db1 := db;
            for ti := 1 to p^.rf^.n do
            with p^.rf^ do
            begin
              OutType (p^.rf^.typs[ti], p^.rf^.nams[ti], db1);
              db1 := db1 + p^.rf^.typs[ti]^.sz;
            end;
            db := db1;
            if p^.rf^.CaseNam <> '' then
               begin
                 OutType (p^.rf^.CaseTyp, @(p^.rf^.CaseNam), db);
                 db := db + p^.rf^.casetyp^.sz;
               end;
            if p^.rf^.Cf <> nil then
               begin
                 for i := 1 to p^.rf^.cf^.n do
                   begin
                   OutType(p^.rf^.cf^.r[i], nil, db);
                   end;
               end;

            outs[0] := char(sla);
          end;
   _set: begin
           tw := 0;
           write ('[');
           Readbytes (TSet, p^.sz, db);
           for j := p^.xx to p^.yy do
           begin
             i := j; {???}
             if Tset[(i-p^.xx div 8 * 8) div 8] and (1 shl ((i-p^.xx div 8 * 8) mod 8)) > 0
              then begin
                     if tw > 0 then write(',');
                     if p^.arrt^.typ in [_char, _String] then
                            begin
                              if i < 32 then write('#',i) else
                              write(#39,char(i),#39);   { Fixed! }
                            end else
                     if p^.arrt^.typ = _enum then
                      begin
                        ti := FindConst (p^.arrt, i);
                        if ti = 0 then
                            write (i) else write(CNames[ti]^);
                      end else write(i);
                     inc (tw);
                   end;
           end;
           writeln (']');
         end;
 _array: begin
           b := byte (outs[0]);
           if nm <> nil then OutS := OutS + nm^+'['
                        else OutS := OutS + '['; { Fixed! }
           OutArrayTail (p, db);
           outs[0] := char (b);
         end;
  end;
end;

procedure ReadDump;
var i: word;
begin
  i := 0;
  while CurChar <> ')' do
  begin
    dmp^[i] := Hexbyte;
    inc (i);
  end;
  dmpl := i-1;
end;

procedure AnalyzeQueries;
var i: integer;
begin
  if (CurLex = _Ident) and (CurIdent = 'QUERIES') then next;
  while CurLex in [_SizeInBits, _SizeInbytes, _Ident] do
  case CurLex of
    _Ident:
       begin
         i := TypeNumber (CurIdent);
         next;
         next;
         if CurLex = _Ident then
              begin
                if Names[i]^ = 'SIZEINBYTES' then
                  begin
                    i := TypeNumber (CurIdent);
                    write ('Type ');
                    write (names[i]^);
                    write (' requires ');
                    write (typarr[i]^.sz);
                    writeln (' bytes');
                  end else
                  begin
                    i := TypeNumber (CurIdent);
                    write ('Type ');
                    write (names[i]^);
                    write (' requires ');
                    write (typarr[i]^.sb);
                    writeln (' bits');
                  end;

              end else
              begin
                outs := '';
                ReadDump;
                OutType (TypArr[i], nil, 0);
              end;
                next;
                next;
       end;

    _SizeInBytes:
       begin
         next;
         next;
           i := TypeNumber (CurIdent);
           write ('Type ');
           write (names[i]^);
           write (' requires ');
           write (typarr[i]^.sz);
           writeln (' bytes');
         next;
         next;
       end;
    _SizeInBits:
       begin
         next;
         next;
           i := TypeNumber (CurIdent);
           write ('Type ');
           write (names[i]^);
           write (' requires ');
           write (typarr[i]^.sb);
           writeln (' bits');
         next;
         next;
       end;
  end;
end;

begin
new(dmp);
{  writeln; writeln ('---------');}
  assign (output, 'output.txt'); rewrite(output);
  LexInit;
  SynInit;
  AnalyzeTypes;
  AnalyzeQueries;
  Close (LexFile);
  close (output);
end.